- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# MittelmannBndryCntrlNeumBase Class Reference

Base class for boundary control problems with Neumann boundary conditions, as formulated by Hans Mittelmann as Examples 5-8 in "Optimization Techniques for Solving Elliptic Control Problems with Control and State Constraints. More...

`#include <MittelmannBndryCntrlNeum.hpp>`

Inheritance diagram for MittelmannBndryCntrlNeumBase:

[legend]
Collaboration diagram for MittelmannBndryCntrlNeumBase:

[legend]
List of all members.

## Public Member Functions
| MittelmannBndryCntrlNeumBase ()
| Constructor.
virtual | ~MittelmannBndryCntrlNeumBase ()
| Default destructor.
virtual bool | get_scaling_parameters (Number &obj_scaling, bool &use_x_scaling, Index n, Number *x_scaling, bool &use_g_scaling, Index m, Number *g_scaling)
| Method for returning scaling parameters.
Overloaded from TNLP
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp.
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem.
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm.
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value.
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective.
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals.
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).
Solution Methods
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called after the optimization, and could write an output file with the optimal profiles.
## Protected Member Functions
void | SetBaseParameters (Index N, Number alpha, Number lb_y, Number ub_y, Number lb_u, Number ub_u, Number u_init)
| Method for setting the internal parameters that define the problem.
Functions that defines a particular instance.
virtual Number | y_d_cont (Number x1, Number x2) const =0
| Target profile function for y (and initial guess function).
virtual Number | d_cont (Number x1, Number x2, Number y) const =0
| Forcing function for the elliptic equation.
virtual Number | d_cont_dy (Number x1, Number x2, Number y) const =0
| First partial derivative of forcing function w.r.t.
virtual Number | d_cont_dydy (Number x1, Number x2, Number y) const =0
| Second partial derivative of forcing function w.r.t.
virtual bool | d_cont_dydy_alwayszero () const =0
| returns true if second partial derivative of d_cont w.r.t.
virtual Number | b_cont (Number x1, Number x2, Number y, Number u) const =0
| Function in Neuman boundary condition.
virtual Number | b_cont_dy (Number x1, Number x2, Number y, Number u) const =0
| First partial derivative of b_cont w.r.t.
virtual Number | b_cont_du (Number x1, Number x2, Number y, Number u) const =0
| First partial derivative of b_cont w.r.t.
virtual Number | b_cont_dydy (Number x1, Number x2, Number y, Number u) const =0
| Second partial derivative of b_cont w.r.t.
virtual bool | b_cont_dydy_alwayszero () const =0
| returns true if second partial derivative of b_cont w.r.t.
## Private Member Functions
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| MittelmannBndryCntrlNeumBase (const MittelmannBndryCntrlNeumBase &)
MittelmannBndryCntrlNeumBase & | operator= (const MittelmannBndryCntrlNeumBase &)
Auxilliary methods
Index | y_index (Index i, Index j) const
| Translation of mesh point indices to NLP variable indices for y(x_ij).
Index | u0j_index (Index j) const
| Translation of mesh point indices to NLP variable indices for u(x_ij) on {0} x (0,1) boudnary.
Index | u1j_index (Index j) const
| Translation of mesh point indices to NLP variable indices for u(x_ij) on {1} x (0,1) boudnary.
Index | ui0_index (Index j) const
| Translation of mesh point indices to NLP variable indices for u(x_ij) on (0,1) x {0} boudnary.
Index | ui1_index (Index j) const
| Translation of mesh point indices to NLP variable indices for u(x_ij) on (0,1) x {1} boudnary.
Number | x1_grid (Index i) const
| Compute the grid coordinate for given index in x1 direction.
Number | x2_grid (Index j) const
| Compute the grid coordinate for given index in x2 direction.
## Private Attributes
Problem specification
Index | N_
| Number of mesh points in one dimension (excluding boundary).
Number | h_
| Step size.
Number | hh_
| h_ squaredd
Number | lb_y_
| overall lower bound on y
Number | ub_y_
| overall upper bound on y
Number | lb_u_
| overall lower bound on u
Number | ub_u_
| overall upper bound on u
Number | u_init_
| Initial value for the constrols u.
Number | alpha_
| Weighting parameter for the control target deviation functional in the objective.
Number * | y_d_
| Array for the target profile for y.

## Detailed Description

Base class for boundary control problems with Neumann boundary conditions, as formulated by Hans Mittelmann as Examples 5-8 in "Optimization Techniques for Solving Elliptic Control Problems with Control and State Constraints.

Part 1: Boundary Control"

Definition at line 33 of file MittelmannBndryCntrlNeum.hpp.

## Constructor & Destructor Documentation

MittelmannBndryCntrlNeumBase::MittelmannBndryCntrlNeumBase | ( |  | ) |

Constructor.

N is the number of mesh points in one dimension (excluding boundary).

virtual MittelmannBndryCntrlNeumBase::~MittelmannBndryCntrlNeumBase | ( |  | ) | `[virtual]`

Default destructor.

MittelmannBndryCntrlNeumBase::MittelmannBndryCntrlNeumBase | ( | const MittelmannBndryCntrlNeumBase & |  | ) | `[private]`

## Member Function Documentation

virtual bool MittelmannBndryCntrlNeumBase::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style |
| ) |  |  | `[virtual]`

Method to return some info about the nlp.

virtual bool MittelmannBndryCntrlNeumBase::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u |
| ) |  |  | `[virtual]`

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda |
| ) |  |  | `[virtual]`

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value |
| ) |  |  | `[virtual]`

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f |
| ) |  |  | `[virtual]`

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g |
| ) |  |  | `[virtual]`

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL).

Implements Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values |
| ) |  |  | `[virtual]`

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL).

Reimplemented from Ipopt::TNLP.

virtual bool MittelmannBndryCntrlNeumBase::get_scaling_parameters | ( | Number & | obj_scaling,
|  | bool & | use_x_scaling,
|  | Index | n,
|  | Number * | x_scaling,
|  | bool & | use_g_scaling,
|  | Index | m,
|  | Number * | g_scaling |
| ) |  |  | `[virtual]`

Method for returning scaling parameters.

Reimplemented from Ipopt::TNLP.

virtual void MittelmannBndryCntrlNeumBase::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

This method is called after the optimization, and could write an output file with the optimal profiles.

void MittelmannBndryCntrlNeumBase::SetBaseParameters | ( | Index | N,
|  | Number | alpha,
|  | Number | lb_y,
|  | Number | ub_y,
|  | Number | lb_u,
|  | Number | ub_u,
|  | Number | u_init |
| ) |  |  | `[protected]`

Method for setting the internal parameters that define the problem.

It must be called by the child class in its implementation of InitializeParameters.

Referenced by MittelmannBndryCntrlNeum4::InitializeProblem(), MittelmannBndryCntrlNeum3::InitializeProblem(), MittelmannBndryCntrlNeum2::InitializeProblem(), and MittelmannBndryCntrlNeum1::InitializeProblem().

virtual Number MittelmannBndryCntrlNeumBase::y_d_cont | ( | Number | x1,
|  | Number | x2 |
| ) |  |  | const`[protected, pure virtual]`

Target profile function for y (and initial guess function).

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::d_cont | ( | Number | x1,
|  | Number | x2,
|  | Number | y |
| ) |  |  | const`[protected, pure virtual]`

Forcing function for the elliptic equation.

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::d_cont_dy | ( | Number | x1,
|  | Number | x2,
|  | Number | y |
| ) |  |  | const`[protected, pure virtual]`

First partial derivative of forcing function w.r.t.

y

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::d_cont_dydy | ( | Number | x1,
|  | Number | x2,
|  | Number | y |
| ) |  |  | const`[protected, pure virtual]`

Second partial derivative of forcing function w.r.t.

y,y

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual bool MittelmannBndryCntrlNeumBase::d_cont_dydy_alwayszero | ( |  | ) | const`[protected, pure virtual]`

returns true if second partial derivative of d_cont w.r.t.

y,y is always zero.

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::b_cont | ( | Number | x1,
|  | Number | x2,
|  | Number | y,
|  | Number | u |
| ) |  |  | const`[protected, pure virtual]`

Function in Neuman boundary condition.

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::b_cont_dy | ( | Number | x1,
|  | Number | x2,
|  | Number | y,
|  | Number | u |
| ) |  |  | const`[protected, pure virtual]`

First partial derivative of b_cont w.r.t.

y

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::b_cont_du | ( | Number | x1,
|  | Number | x2,
|  | Number | y,
|  | Number | u |
| ) |  |  | const`[protected, pure virtual]`

First partial derivative of b_cont w.r.t.

u

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual Number MittelmannBndryCntrlNeumBase::b_cont_dydy | ( | Number | x1,
|  | Number | x2,
|  | Number | y,
|  | Number | u |
| ) |  |  | const`[protected, pure virtual]`

Second partial derivative of b_cont w.r.t.

y,y

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

virtual bool MittelmannBndryCntrlNeumBase::b_cont_dydy_alwayszero | ( |  | ) | const`[protected, pure virtual]`

returns true if second partial derivative of b_cont w.r.t.

y,y is always zero.

Implemented in MittelmannBndryCntrlNeum1, MittelmannBndryCntrlNeum2, MittelmannBndryCntrlNeum3, and MittelmannBndryCntrlNeum4.

MittelmannBndryCntrlNeumBase& MittelmannBndryCntrlNeumBase::operator= | ( | const MittelmannBndryCntrlNeumBase & |  | ) | `[private]`

Index MittelmannBndryCntrlNeumBase::y_index | ( | Index | i,
|  | Index | j |
| ) |  |  | const`[inline, private]`

Translation of mesh point indices to NLP variable indices for y(x_ij).

Definition at line 185 of file MittelmannBndryCntrlNeum.hpp.

References N_.

Index MittelmannBndryCntrlNeumBase::u0j_index | ( | Index | j | ) | const`[inline, private]`

Translation of mesh point indices to NLP variable indices for u(x_ij) on {0} x (0,1) boudnary.

Definition at line 191 of file MittelmannBndryCntrlNeum.hpp.

References N_.

Index MittelmannBndryCntrlNeumBase::u1j_index | ( | Index | j | ) | const`[inline, private]`

Translation of mesh point indices to NLP variable indices for u(x_ij) on {1} x (0,1) boudnary.

Definition at line 197 of file MittelmannBndryCntrlNeum.hpp.

References N_.

Index MittelmannBndryCntrlNeumBase::ui0_index | ( | Index | j | ) | const`[inline, private]`

Translation of mesh point indices to NLP variable indices for u(x_ij) on (0,1) x {0} boudnary.

Definition at line 203 of file MittelmannBndryCntrlNeum.hpp.

References N_.

Index MittelmannBndryCntrlNeumBase::ui1_index | ( | Index | j | ) | const`[inline, private]`

Translation of mesh point indices to NLP variable indices for u(x_ij) on (0,1) x {1} boudnary.

Definition at line 209 of file MittelmannBndryCntrlNeum.hpp.

References N_.

Number MittelmannBndryCntrlNeumBase::x1_grid | ( | Index | i | ) | const`[inline, private]`

Compute the grid coordinate for given index in x1 direction.

Definition at line 214 of file MittelmannBndryCntrlNeum.hpp.

References h_.

Number MittelmannBndryCntrlNeumBase::x2_grid | ( | Index | j | ) | const`[inline, private]`

Compute the grid coordinate for given index in x2 direction.

Definition at line 219 of file MittelmannBndryCntrlNeum.hpp.

References h_.

## Member Data Documentation

Index MittelmannBndryCntrlNeumBase::N_`[private]`

Number of mesh points in one dimension (excluding boundary).

Definition at line 159 of file MittelmannBndryCntrlNeum.hpp.

Referenced by u0j_index(), u1j_index(), ui0_index(), ui1_index(), and y_index().

Number MittelmannBndryCntrlNeumBase::h_`[private]`

Step size.

Definition at line 161 of file MittelmannBndryCntrlNeum.hpp.

Referenced by x1_grid(), and x2_grid().

Number MittelmannBndryCntrlNeumBase::hh_`[private]`

h_ squaredd

Definition at line 163 of file MittelmannBndryCntrlNeum.hpp.

Number MittelmannBndryCntrlNeumBase::lb_y_`[private]`

overall lower bound on y

Definition at line 165 of file MittelmannBndryCntrlNeum.hpp.

Number MittelmannBndryCntrlNeumBase::ub_y_`[private]`

overall upper bound on y

Definition at line 167 of file MittelmannBndryCntrlNeum.hpp.

Number MittelmannBndryCntrlNeumBase::lb_u_`[private]`

overall lower bound on u

Definition at line 169 of file MittelmannBndryCntrlNeum.hpp.

Number MittelmannBndryCntrlNeumBase::ub_u_`[private]`

overall upper bound on u

Definition at line 171 of file MittelmannBndryCntrlNeum.hpp.

Number MittelmannBndryCntrlNeumBase::u_init_`[private]`

Initial value for the constrols u.

Definition at line 173 of file MittelmannBndryCntrlNeum.hpp.

Number MittelmannBndryCntrlNeumBase::alpha_`[private]`

Weighting parameter for the control target deviation functional in the objective.

Definition at line 176 of file MittelmannBndryCntrlNeum.hpp.

Number* MittelmannBndryCntrlNeumBase::y_d_`[private]`

Array for the target profile for y.

Definition at line 178 of file MittelmannBndryCntrlNeum.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/examples/ScalableProblems/MittelmannBndryCntrlNeum.hpp